use super::reader::Reader;



///
pub enum Lexer
{
}


/// Determines if a character is alphabetic.
fn is_alpha(c: char) -> bool
{
   c.is_alphabetic()
}

/// Determines if a character is a numeral
fn is_numeric(c: char) -> bool
{
   c.is_numeric()
}

/// Determines if a character is whitespace.
fn is_whitespace(c: char) -> bool
{
   c.is_whitespace()
}

/// Returns true if the next set of characters starts with
/// the given pattern; Otherwise, false.
fn starts_with<P>(pattern: P) -> bool
   where P: AsRef<str>
{
   false
}

/// Consume and discard zero or more whitespace characters.
fn consume_whitespace()
{
   consume_while(is_whitespace);
}

/// Consume characters until the test returns false.
fn consume_while<F>(test: F) -> String
   where F: Fn(char) -> bool
{
   String::new()
}



impl Lexer
{
   /// Scan the data held by the Reader. This will consume the Reader and
   /// clear it.
   pub fn scan(reader: Reader) -> Result<Vec<String>, String>
   {
      let tokens: Vec<String>;

      // Create a new list to hold all the discovered tokens.
      tokens = Vec::new();

      // Return the scanned tokens.
      Ok(tokens)
   }
}
